      DOUBLE PRECISION FUNCTION FINT2(U)                                
C    ****************************************************************** 
C    *                                                                * 
C    * INTEGRATION OVER THE AZIMUTAL ANGLE FROM 0.0 TO PHI < PI       * 
C    *                                                                * 
C    ****************************************************************** 
      LOGICAL RATION,USER                                               
      DOUBLE PRECISION A,ARG,B,B2,C,CCOEF,COSPSI,DLIMF,ELLEPS,PHI,      
     ,PHINT,RU,SINPSI,SURLOS,U,UM,USURLO,T,TANPSI,WN,X                  
      COMMON/PARAM/A,B,CCOEF,ELLEPS,COSPSI,SINPSI,TANPSI,RU,UM,DLIMF,   
     ,             WN,USER,RATION                                       
      IF(U.EQ.0.0D0) THEN                                               
         FINT2 = 0.0D0                                                  
         RETURN                                                         
      ENDIF                                                             
      B2 = B**2                                                         
      C = (1.0D0-ELLEPS)*(COSPSI*U)**2+(B-CCOEF)*(B+CCOEF)              
      IF(ABS(A*C).GT.1.0D-03*B2) THEN                                   
         X = (B-SQRT(B2-A*C))/A                                         
      ELSE                                                              
         X = A*C/B2                                                     
         X = 0.5D0*C*(1.D0+0.25D0*X*(1.D0+0.5D0*X*(1.D0+0.625D0*X)))/B  
      ENDIF                                                             
      ARG = X/U                                                         
      IF(ABS(ARG).GT.1.0D0) ARG = SIGN(1.0D0,ARG)                       
      PHI = ACOS(ARG)                                                   
      FINT2 = PHINT(PHI,TANPSI,U)                                       
      IF(RATION) RETURN                                                 
      IF(USER) THEN                                                     
         FINT2 = FINT2*USURLO(RU*U,WN)                                  
      ELSE                                                              
         FINT2 = FINT2*SURLOS(RU*U)                                     
         IF(DLIMF.GT.0.0D0) THEN                                        
            T = RU*U*DLIMF                                              
            FINT2 = FINT2*(1.D0+T*LOG(T/(T+0.26D0)))**2/(1.D0+1.40D0*T) 
         ENDIF                                                          
      ENDIF                                                             
      RETURN                                                            
      END                                                               
