      DOUBLE PRECISION FUNCTION PHINT(PHI,A,U)                          
C    ****************************************************************** 
C    *                                                                * 
C    * EVALUATE THE INTEGRAL FROM ZERO TO PHI OF                      * 
C    *                                                                * 
C    *                 U                 2                            * 
C    *  ( ----------------------------- )  DPHI                       * 
C    *                          2     2                               * 
C    *    (1 - A * U * COS(PHI))  +  U                                * 
C    *                                                                * 
C    * FOR 0 <= PHI <= PI , U >= 0 AND A >= 0                         * 
C    *                                                                * 
C    ****************************************************************** 
      DOUBLE PRECISION A,AI,AR,BI,BR,C,CPR,D,E,ESR,PI,PHI,QR,RI,RM,ROOT,
     ,RP,RR,S,SPR,TM,TP,U,U2,X,ZETA,ZETAI,ZETAR,ZR                      
      PI = 3.141592653589793238D0                                       
      C = COS(PHI)                                                      
      S = SIN(PHI)                                                      
      U2 = U**2                                                         
      E = A*U                                                           
      IF(U.LT.1.0D0 .AND. E.LT.1.0D-02*(1.0D0+U2)) GOTO 5               
      RM = SQRT((1.0D0-E)**2+U2)                                        
      RP = SQRT((1.0D0+E)**2+U2)                                        
      ROOT = SQRT(RM*RP)                                                
      TM = 0.5D0*ATAN2(U,1.0D0-E)                                       
      TP = 0.5D0*ATAN2(U,1.0D0+E)                                       
      CPR = COS(TM+TP)                                                  
      SPR = SIN(TM+TP)                                                  
      IF(C.GE.0.0D0) GOTO 2                                             
      IF(ABS(S).GT.1.0D-07) GOTO 1                                      
      RR = -PI/ROOT*CPR                                                 
      RI = PI/ROOT*SPR                                                  
      AR = -RR+U*RI                                                     
      AI = -RI-U*RR                                                     
      GOTO 4                                                            
    1 X = (1.0D0-C)/S                                                   
      GOTO 3                                                            
    2 X = S/(1.0D0+C)                                                   
    3 ZETA = SQRT(RM/RP)                                                
      ZETAR = -ZETA*SIN(TM-TP)                                          
      ZETAI = ZETA*COS(TM-TP)                                           
      BR = 0.5D0*LOG(((ZETAR+X)**2+ZETAI**2)/((ZETAR-X)**2+ZETAI**2))   
      BI = ATAN2(ZETAI,ZETAR+X)-ATAN2(ZETAI,ZETAR-X)                    
      RR = -1.0D0/ROOT*(BR*SPR-BI*CPR)                                  
      RI = -1.0D0/ROOT*(BI*SPR+BR*CPR)                                  
      D = E*S/((1.0D0-E*C)**2+U2)                                       
      AR = D*(1.0D0-E*C)-RR+U*RI                                        
      AI = -D*U-RI-U*RR                                                 
    4 QR = 1.0D0/(RM*RP)*(AR*(CPR-SPR)*(CPR+SPR)+2.0D0*AI*CPR*SPR)      
      PHINT = 0.5D0*(RI/U-QR)                                           
      RETURN                                                            
    5 ZR = 1.0D0+U2                                                     
      ESR = E/ZR                                                        
      PHINT = U2/ZR**2*((( (4.D0/3.D0)*(2.0D0+C**2)*S*(5.0D0-3.0D0*U2)* 
     *             ESR + (PHI+C*S)*(5.D0-U2))*ESR + 4.0D0*S)*ESR + PHI) 
      RETURN                                                            
      END                                                               
